Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.tree
Class TreeBuilder

    java.lang.Object
      net.sf.saxon.event.Builder
          net.sf.saxon.tree.TreeBuilder

All Implemented Interfaces:
  Receiver, javax.xml.transform.Result

public class TreeBuilder
extends Builder

The Builder class is responsible for taking a stream of SAX events and constructing a Document tree.

Field Summary

Fields inherited from class net.sf.saxon.event.Builder
`config, currentRoot, lineNumbering, LINKED_TREE, namePool, pipe, STANDARD_TREE, started, systemId, timing, TINY_TREE`

Fields inherited from interface javax.xml.transform.Result
`PI_DISABLE_OUTPUT_ESCAPING, PI_ENABLE_OUTPUT_ESCAPING`

Constructor Summary
`TreeBuilder()` create a Builder and initialise variables

Method Summary
`void` | `attribute(int nameCode, int typeCode, java.lang.CharSequence value, int locationId, int properties)` Notify an attribute.
`void` | `characters(java.lang.CharSequence chars, int locationId, int properties)` Notify a text node.
`void` | `close()` Callback interface for SAX: not for application use
`void` | `comment(java.lang.CharSequence chars, int locationId, int properties)` Notify a comment
`void` | `endElement()` Notify the end of an element
`void` | `graftElement(ElementImpl element)` graftElement() allows an element node to be transferred from one tree to another.
`void` | `namespace(int namespaceCode, int properties)` Notify a namespace.
`void` | `open()` Callback interface for SAX: not for application use
`void` | `processingInstruction(java.lang.String name, java.lang.CharSequence remainder, int locationId, int properties)` Notify a processing instruction
`void` | `setNodeFactory(NodeFactory factory)` Set the Node Factory to use.
`void` | `setUnparsedEntity(java.lang.String name, java.lang.String uri, java.lang.String publicId)` Set an unparsed entity URI for the document
`void` | `startContent()` Notify the start of the content, that is, the completion of all attributes and namespaces.
`void` | `startElement(int nameCode, int typeCode, int locationId, int properties)` Notify the start of an element

Methods inherited from class net.sf.saxon.event.Builder
`build, build, endDocument, getConfiguration, getCurrentRoot, getPipelineConfiguration, getSystemId, isTiming, setLineNumbering, setPipelineConfiguration, setSystemId, setTiming, startDocument`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### TreeBuilder

    public TreeBuilder()

  create a Builder and initialise variables

Method Detail

### setNodeFactory

    public void setNodeFactory(NodeFactory factory)

  Set the Node Factory to use. If none is specified, the Builder uses its own.

### open

    public void open()
              throws XPathException

  Callback interface for SAX: not for application use

  Specified by:
    `open` in interface `Receiver`
  Overrides:
    `open` in class `Builder`
  Throws:
    `XPathException`

### close

    public void close()
               throws XPathException

  Callback interface for SAX: not for application use

  Specified by:
    `close` in interface `Receiver`
  Overrides:
    `close` in class `Builder`
  Throws:
    `XPathException`

### startElement

    public void startElement(int nameCode,
                             int typeCode,
                             int locationId,
                             int properties)
                      throws XPathException

  Notify the start of an element

  Parameters:
    `nameCode` - integer code identifying the name of the element within the name pool.
    `typeCode` - integer code identifying the element's type within the name pool. The value -1 indicates the default type, xdt:untyped.
    `locationId` - an integer which can be interpreted using a LocationMap to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - bit-significant properties of the element node. If there are no revelant properties, zero is supplied.
  Throws:
    `XPathException`

### namespace

    public void namespace(int namespaceCode,
                          int properties)

  Description copied from interface: `Receiver`
  Notify a namespace. Namespaces are notified after the startElement event, and before any children for the element. The namespaces that are reported are only required to include those that are different from the parent element. The events represent namespace declarations and undeclarations rather than in-scope namespace nodes: an undeclaration is represented by a namespace code of zero. If the sequence of namespace events contains two A namespace must not conflict with any namespaces already used for element or attribute names.

  Parameters:
    `namespaceCode` - an integer: the top half is a prefix code, the bottom half a URI code. These may be translated into an actual prefix and URI using the name pool. A prefix code of zero represents the empty prefix (that is, the default namespace). A URI code of zero represents a URI of "", that is, a namespace undeclaration.
    `properties` - The most important property is REJECT_DUPLICATES. If this property is set, the namespace declaration will be rejected if it conflicts with a previous declaration of the same prefix. If the property is not set, the namespace declaration will be ignored if it conflicts with a previous declaration. This reflects the fact that when copying a tree, namespaces for child elements are emitted before the namespaces of their parent element. Unfortunately this conflicts with the XSLT rule for complex content construction, where the recovery action in the event of conflicts is to take the namespace that comes last. XSLT therefore doesn't recover from this error: it sets the REJECT_DUPLICATES flag, and this is treated as a hard error.

### attribute

    public void attribute(int nameCode,
                          int typeCode,
                          java.lang.CharSequence value,
                          int locationId,
                          int properties)
                   throws XPathException

  Description copied from interface: `Receiver`
  Notify an attribute. Attributes are notified after the startElement event, and before any children. Namespaces and attributes may be intermingled.

  Parameters:
    `nameCode` - The name of the attribute, as held in the name pool
    `typeCode` - The type of the attribute, as held in the name pool. The additional bit NodeInfo.IS_DTD_TYPE may be set to indicate a DTD-derived type.
    `locationId` - an integer which can be interpreted using a LocationMap to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Bit significant value. The following bits are defined:
  DISABLE_ESCAPING
    Disable escaping for this attribute
  NO_SPECIAL_CHARACTERS
    Attribute value contains no special characters
  Throws:
    `XPathException`

### startContent

    public void startContent()
                      throws XPathException

  Description copied from interface: `Receiver`
  Notify the start of the content, that is, the completion of all attributes and namespaces. Note that the initial receiver of output from XSLT instructions will not receive this event, it has to detect it itself. Note that this event is reported for every element even if it has no attributes, no namespaces, and no content.

  Throws:
    `XPathException`

### endElement

    public void endElement()
                    throws XPathException

  Notify the end of an element

  Throws:
    `XPathException`

### characters

    public void characters(java.lang.CharSequence chars,
                           int locationId,
                           int properties)
                    throws XPathException

  Notify a text node. Adjacent text nodes must have already been merged

  Parameters:
    `chars` - The characters
    `locationId` - an integer which can be interpreted using a LocationMap to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Bit significant value. The following bits are defined:
  DISABLE_ESCAPING
    Disable escaping for this text node
  USE_CDATA
    Output as a CDATA section
  NO_SPECIAL_CHARACTERS
    Value contains no special characters
  WHITESPACE
    Text is all whitespace
  Throws:
    `XPathException`

### processingInstruction

    public void processingInstruction(java.lang.String name,
                                      java.lang.CharSequence remainder,
                                      int locationId,
                                      int properties)

  Notify a processing instruction

  Parameters:
    `name` - The PI name. This must be a legal name (it will not be checked).
    `remainder` - The data portion of the processing instruction
    `locationId` - an integer which can be interpreted using a LocationMap to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Additional information about the PI. The following bits are defined:
  CHECKED
    Data is known to be legal (e.g. doesn't contain "?>")

### comment

    public void comment(java.lang.CharSequence chars,
                        int locationId,
                        int properties)
                 throws XPathException

  Notify a comment

  Parameters:
    `chars` - The content of the comment
    `locationId` - an integer which can be interpreted using a LocationMap to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Additional information about the comment. The following bits are defined:
  CHECKED
    Comment is known to be legal (e.g. doesn't contain "--")
  Throws:
    `XPathException`

### graftElement

    public void graftElement(ElementImpl element)
                      throws XPathException

  graftElement() allows an element node to be transferred from one tree to another. This is a dangerous internal interface which is used only to contruct a stylesheet tree from a stylesheet using the "literal result element as stylesheet" syntax. The supplied element is grafted onto the current element as its only child.

  Throws:
    `XPathException`

### setUnparsedEntity

    public void setUnparsedEntity(java.lang.String name,
                                  java.lang.String uri,
                                  java.lang.String publicId)

  Set an unparsed entity URI for the document

  Parameters:
    `name` - The name of the unparsed entity
    `uri` - The system identifier of the unparsed entity
    `publicId` - The public identifier of the unparsed entity

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD